﻿--
-- Script was generated by Devart dbForge Studio 2020 for MySQL, Version 9.0.897.0
-- Product home page: http://www.devart.com/dbforge/mysql/studio
-- Script date 29/12/2022 11:02:32
-- Server version: 8.0.30
-- Client version: 4.1
--

-- 
-- Disable foreign keys
-- 
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;

-- 
-- Set SQL mode
-- 
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;

-- 
-- Set character set the client will use to send SQL statements to the server
--
SET NAMES 'utf8';

--
-- Set default database
--
USE disparadores;

--
-- Drop table `historico`
--
DROP TABLE IF EXISTS historico;

--
-- Drop table `noticias`
--
DROP TABLE IF EXISTS noticias;

--
-- Set default database
--
USE disparadores;

--
-- Create table `noticias`
--
CREATE TABLE noticias (
  id int NOT NULL AUTO_INCREMENT,
  texto varchar(100) DEFAULT NULL,
  titulo varchar(100) DEFAULT NULL,
  longitud int DEFAULT NULL,
  fecha date DEFAULT NULL,
  dia int DEFAULT NULL,
  mes varchar(20) DEFAULT NULL,
  PRIMARY KEY (id)
)
ENGINE = INNODB,
AUTO_INCREMENT = 15,
AVG_ROW_LENGTH = 1365,
CHARACTER SET utf8mb4,
COLLATE utf8mb4_0900_ai_ci;

--
-- Create table `historico`
--
CREATE TABLE historico (
  id int NOT NULL AUTO_INCREMENT,
  dia int DEFAULT NULL,
  numero int DEFAULT 0,
  PRIMARY KEY (id)
)
ENGINE = INNODB,
AUTO_INCREMENT = 9,
AVG_ROW_LENGTH = 3276,
CHARACTER SET utf8mb4,
COLLATE utf8mb4_0900_ai_ci;

-- 
-- Dumping data for table noticias
--
INSERT INTO noticias VALUES
(1, 'ejemplo de noticia larga', 'larga', 24, '2022-12-01', 1, 'December'),
(2, 'ejemplo de noticia corta', 'corta', 24, '2022-01-12', 12, 'January'),
(5, 'ejemplo noticias', 'ti1', 16, '2022-05-08', 8, 'May'),
(6, 'ejemplo noticias 1', 'ti2', 18, '2022-08-07', 7, 'August'),
(7, 'EJEMPLO NUEVA', 'nueva', 13, '2022-05-19', 19, 'May'),
(8, 'EJEMPLO NUEVA 1', 'nueva 2', 15, '2022-05-08', 8, 'May'),
(9, 'EJEMPLO NUEVA', 'nueva', 13, '2022-05-19', 19, 'May'),
(10, 'EJEMPLO NUEVA 1', 'nueva 2', 15, '2022-05-08', 8, 'May'),
(11, 'EJEMPLO NUEVA', 'nueva', 13, '2022-05-19', 19, 'May'),
(12, 'EJEMPLO NUEVA 1', 'nueva 2', 15, '2022-05-08', 8, 'May'),
(13, 'EJEMPLO NUEVA', 'nueva', 13, '2022-05-19', 19, 'May'),
(14, 'EJEMPLO NUEVA 1', 'nueva 2', 15, '2022-05-08', 8, 'May');

-- 
-- Dumping data for table historico
--
INSERT INTO historico VALUES
(1, 1, 1),
(2, 12, 1),
(3, 8, 5),
(4, 7, 1),
(8, 19, 4);

--
-- Set default database
--
USE disparadores;

--
-- Drop trigger `adnoticias`
--
DROP TRIGGER IF EXISTS adnoticias;

--
-- Drop trigger `ainoticias`
--
DROP TRIGGER IF EXISTS ainoticias;

--
-- Drop trigger `bunoticias`
--
DROP TRIGGER IF EXISTS bunoticias;

--
-- Drop trigger `binoticias2`
--
DROP TRIGGER IF EXISTS binoticias2;

--
-- Drop trigger `binoticias`
--
DROP TRIGGER IF EXISTS binoticias;

--
-- Set default database
--
USE disparadores;

DELIMITER $$

--
-- Create trigger `binoticias`
--
CREATE
DEFINER = 'root'@'localhost'
TRIGGER binoticias
BEFORE INSERT
ON noticias
FOR EACH ROW
BEGIN
  SET NEW.longitud = CHAR_LENGTH(NEW.texto);
END
$$

--
-- Create trigger `binoticias2`
--
CREATE
DEFINER = 'root'@'localhost'
TRIGGER binoticias2
BEFORE INSERT
ON noticias
FOR EACH ROW
FOLLOWS binoticias
BEGIN
  SET New.dia = DAY(NEW.fecha), New.mes = MONTHNAME(New.fecha);
END
$$

--
-- Create trigger `bunoticias`
--
CREATE
DEFINER = 'root'@'localhost'
TRIGGER bunoticias
BEFORE UPDATE
ON noticias
FOR EACH ROW
BEGIN
  SET NEW.longitud = CHAR_LENGTH(NEW.texto),
  NEW.dia = DAY(NEW.fecha),
  NEW.mes = MONTHNAME(NEW.fecha);
END
$$

--
-- Create trigger `ainoticias`
--
CREATE
DEFINER = 'root'@'localhost'
TRIGGER ainoticias
AFTER INSERT
ON noticias
FOR EACH ROW
BEGIN
  DECLARE contador int DEFAULT 0;

  SELECT
    COUNT(*) INTO contador -- si contador=1 el dia ya esta en historico
  FROM historico h
  WHERE h.dia = NEW.dia;

  IF (contador = 1) THEN
    -- SI CONTADOR ES 1 INDICA QUE EN HISTORICO YA TENIA NOTICIAS DE ESE DIA
    -- SOLAMENTE TENGO QUE SUMAR 1
    UPDATE historico h
    SET h.numero = h.numero + 1
    WHERE h.dia = NEW.dia;
  ELSE
    -- SI CONTADOR ES 0 INDICA QUE EN HISTORICO EL DIA NO EXISTE
    -- NO TENGO NOTICIAS DE ESE DIA
    -- TENGO QUE INSERTAR UN REGISTRO NUEVO
    INSERT INTO historico (dia, numero)
      VALUES (NEW.dia, 1);
  END IF;


END
$$

--
-- Create trigger `adnoticias`
--
CREATE
DEFINER = 'root'@'localhost'
TRIGGER adnoticias
AFTER DELETE
ON noticias
FOR EACH ROW
BEGIN
  UPDATE historico h
  SET h.numero = h.numero - 1
  WHERE h.dia = OLD.dia;
END
$$

DELIMITER ;

-- 
-- Restore previous SQL mode
-- 
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;

-- 
-- Enable foreign keys
-- 
/*!40014 SET FOREIGN_KEY_CHECKS = @OLD_FOREIGN_KEY_CHECKS */;